
#include <SPI.h>
#include <Ethernet.h>
#include <PubSubClient.h>

#include "SPI.h" 
#include <Adafruit_Sensor.h>
#include "Adafruit_BMP280.h"

//Setup connection of the sensor
Adafruit_BMP280 bmp; // I2C

byte mac[] = {0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};

// IP del servidor MQTT
const char* mqtt_server = "192.168.1.200";



#define TEMP_TOPIC   "firtec/temp"
#define PRES_TOPIC   "firtec/pre"

float p;   
float t;  

long lastMsg = 0;
char msg[20];
boolean bandera = false;

EthernetClient ethClient;
PubSubClient client(ethClient);

void mqttconnect() {
  // Bucle de conexión
  while (!client.connected()) {
    Serial.print("MQTT conectando ...");
    // ID del cliente
    String clientId = "ESP32Client";
   
    if (client.connect(clientId.c_str())) {
      Serial.println("conectado!!");
      
    } else {
      Serial.print("Error, status code =");
      Serial.print(client.state());
      Serial.println("Intentar de nuevo en 5 segundos");
      delay(5000);
    }
  }
}

void setup() {
  bmp.begin();     
  Serial.begin(9600);
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Fallo al configurar Ethernet usando DHCP");
  }
  Serial.print("IP: ");
  Serial.println(Ethernet.localIP());
  client.setServer(mqtt_server, 1883);
 }

void loop() {

  // Si un cliente se desconecta esperar hasta que reconecte
  if (!client.connected()) {
    mqttconnect();
  }
  
  client.loop();
  
  long Ahora = millis();
  if (Ahora - lastMsg > 5000) {
     if(bandera == false) {
    lastMsg = Ahora;
     t = bmp.readTemperature();
     Serial.print(t);
    // Serial.print("\t");
     snprintf (msg, 20, "%2.1f", t);   
     client.publish(TEMP_TOPIC, msg); 
     bandera = true; 
    }
    else {
      lastMsg = Ahora;
      p = bmp.readPressure()/100;
      Serial.print(p);
      //Serial.print("\t");
      snprintf (msg, 20, "%3.1f", p);    
      client.publish(PRES_TOPIC, msg);    
      bandera = false;
      }
     } 
   }
    
